{ķ}
{                      KEYBOARD SPEED Version 1.0                          }
{                  Copyright (C) 1997 by The GodFather                     }
{ͼ}

{$M 1024,0,0}
USES GUtils;

CONST
  Version = 'Version 1.0';

  KeyDelay   : ARRAY[0..3] OF STRING[4] =
   ('0.25','0.50','0.75','1.00');

  RepeatRate : ARRAY[0..31] OF STRING[4] =
   ('30.0','26.7','24.0','21.8','20.0','18.5','17.1','16.0','15.0',
    '13.3','12.0','10.9','10.0', '9.2', '8.6', '8.0', '7.5', '6.7',
     '6.0', '5.5', '5.0', '4.6', '4.3', '4.0', '3.7', '3.3', '3.0',
     '2.7', '2.5', '2.3', '2.1', '2.0');

  OK    : Boolean = True;


PROCEDURE CopyRight;
BEGIN
  Writeln('KEYBOARD SPEED '+Version);
  Writeln('Copyright (C) 1997 by The GodFather');
  Writeln;
END;

PROCEDURE Instructions;
BEGIN
  Writeln(' Usage: KSPEED  KeyRepeatRate        Delay');
  Writeln('                                      ');
  Writeln('                                      ');
  Writeln('            0 - 30.0 reps/sec   0 - 0.25 seconds');
  Writeln('            1 - 26.7 reps/sec   1 - 0.50 seconds');
  Writeln('            2 - 24.0 reps/sec   2 - 0.75 seconds');
  Writeln('            3 - 21.8 reps/sec   3 - 1.00 second');
  Writeln('                     .');
  Writeln('                     .');
  Writeln('                     .');
  Writeln('           28 - 2.5 reps/sec');
  Writeln('           29 - 2.3 reps/sec');
  Writeln('           30 - 2.1 reps/sec');
  Writeln('           31 - 2.0 reps/sec');
  Halt;
END;


{$F+}
 FUNCTION SetTypm(Rate:Byte): Boolean;
 BEGIN
  INLINE($32/$D2/$B4/$F3/$FA/$E8/$13/$00/$75/$0A/$8A/$66/$06/$E8/
         $0B/$00/$75/$02/$FE/$C2/$FB/$88/$56/$FF/$EB/$27/$90/$51/
         $53/$B3/$03/$33/$C9/$E4/$64/$A8/$02/$E0/$FA/$8A/$C4/$E6/
         $60/$E4/$64/$A8/$01/$E1/$FA/$E4/$60/$3C/$FA/$74/$07/$FE/
         $CB/$75/$E6/$80/$CB/$01/$5B/$59/$C3);
 END;
{$F-}


PROCEDURE SetKeyboardSpeed(_Speed,_Delay:Byte);
BEGIN
  OK := SetTypm((_Delay SHL 5) + _Speed)
END;


PROCEDURE ProcessParams;
VAR FPos1,FPos2:Integer;
    Delay,Speed:Byte;

BEGIN
  Val(ParamStr(1), Speed, FPos1);
  Val(ParamStr(2), Delay, FPos2);
  IF ((FPos1=0) AND (FPos2=0)) THEN
  BEGIN
    IF ((Delay < 4) AND (Speed < 32)) THEN
    BEGIN
      SetKeyboardSpeed(Speed,Delay);
      IF OK THEN
      BEGIN
        Writeln(' Repeat rate - '+RepeatRate[Speed]+' chars per second');
        Writeln(' Delay rate  - '+KeyDelay[Delay]+' secs');
      END ELSE Writeln('This program needs MF-II keyboard to work properly');
      Halt;
    END;
  END;
  Instructions;
END;



{ -- MAIN --- }
BEGIN
  Copyright;
  IF ParamCount < 2 THEN Instructions;
  ProcessParams;
END.